# -----------------------------------------------------------------------------
# sample.s
# 017:C SC459100X Computer Architecture
# Sample Program
# Author: Derek Hoshiko
# SID: XXXXXXXXX
# 08/26/2001   07:42
# -----------------------------------------------------------------------------
                .data
# P R O G R A M   C O N S T A N T S
CR:             .byte   '\n'                    # Carriage return character
RCC:            .word   0xFFFF0000              # Receiver control
RCD:            .word   0xFFFF0004              # Receiver data
TRC:            .word   0xFFFF0008              # Transmitter control
TRD:            .word   0xFFFF000C              # Transmitter data

# S T R I N G   C O N S T A N T S
msg:            .asciiz "Hello!"                # Program message

                .text
# P R O C E D U R E   D E F I N I T I O N S
# -----------------------------------------------------------------------------
# Module Name: main
# Description: Displays message 'msg'.  'Msg' must be 6 characters long.
#       Input: None
#      Output: None
# -----------------------------------------------------------------------------
main:           la      $a0,msg                 # Prepare to display message
                jal     put_str_6               # Display message
                li      $v0,10                  # Prepare to exit
                syscall                         # Exit program
# -----------------------------------------------------------------------------
# Module Name: put_str_6
# Description: Prints a character string of 6 characters to the screen.
#       Input: $a0 - 'buf', a pointer to a 6 character long array.
#      Output: None
# -----------------------------------------------------------------------------
put_str_6:      sub     $sp,$sp,8               # Prepare to save registers
                sw      $ra,4($sp)              # Save return address
                sw      $s1,0($sp)              # Save register $s1
                move    $s1,$a0                 # Save parameter 'buf'
ps_top:         lb      $a0,0($s1)              # Get character from 'buf'
                jal     putch                   # Print character to screen
                lb      $a0,1($s1)              # Get character from 'buf'
                jal     putch                   # Print character to screen
                lb      $a0,2($s1)              # Get character from 'buf'
                jal     putch                   # Print character to screen
                lb      $a0,3($s1)              # Get character from 'buf'
                jal     putch                   # Print character to screen
                lb      $a0,4($s1)              # Get character from 'buf'
                jal     putch                   # Print character to screen
                lb      $a0,5($s1)              # Get character from 'buf'
                jal     putch                   # Print character to screen
                lb      $a0,CR                  # Prepare to print newline
                jal     putch                   # Print newline to screen
ps_bottom:      lw      $s1,0($sp)              # Restore saved register
                lw      $ra,4($sp)              # Restore return address
                add     $sp,$sp,8               # Reset stack pointer
                jr      $ra                     # Return to caller
# -----------------------------------------------------------------------------
# Module Name: getch
# Description: Waits for user input from keyboard and returns input character
#       Input: None
#      Output: $v0 - ASCII value of character that was input
# -----------------------------------------------------------------------------
getch:          lw      $t0,RCC                 # Get address of RCC
                lw      $t1,RCD                 # Get address of RCD
g_poll_top:     lw      $t2,0($t0)              # Get status of receiver
                andi    $t2,0x00000001          # Test only ready bit
                beq     $t2,$zero,g_poll_top    # Poll until ready
                lw      $v0,0($t1)              # Return data in RCD
                jr      $ra                     # Return to caller
# -----------------------------------------------------------------------------
# Module Name: putch
# Description: Outputs one character to the user screen
#       Input: $a0 - ASCII value of character to be output
#      Output: None
# -----------------------------------------------------------------------------
putch:          lw      $t0,TRC                 # Get address of TRC
                lw      $t1,TRD                 # Get address of TRD
p_poll_top:     lw      $t2,0($t0)              # Get status of receiver
                andi    $t2,0x00000001          # Test only ready bit
                beq     $t2,$zero,p_poll_top    # Poll until ready
                sw      $a0,0($t1)              # Output to transmitter
                jr      $ra                     # Return to caller